; CyberBox Editor v1.0
; By Alban Gervaise
: last update: 26/01/99


        include "doorsos.h"
        include "userlib.h"
        include "graphlib.h"
        include "filelib.h"
        include "cbe_pic.asm"

        xdef _main
        xdef _ti89
        xdef _comment


mask0 equ %11111110  ;(up\2nd\donw...)
mask1 equ %11111101  ;(Enter\clear...)
mask2 equ %11111011  ;( <- )
mask3 equ %11110111  ;(catalog...)
mask4 equ %11101111  ;(Mode...)
mask5 equ %11011111  ;(Home...)
mask6 equ %10111111  ;(ESC...)

        dc.l 'ICON'
        dc.w %0110010101111111
        dc.w %1000001101111111
        dc.w %0110000101110000
        dc.w %1100011001111111
        dc.w %1010000001111111
        dc.w %1110010101110000
        dc.w %1001001001111111
        dc.w %1110010101111111


_main   bsr int_on
        move.w #1500,speed
        jsr graphlib::gray4                ; initialise la couleur
        bsr clrscr
        clr.w sel_on
        clr.w sel

        move.l #pic1,a0
        move.w #20,d0
        move.w #45,d1
        move.b #%11111111,d3
        jsr graphlib::put_sprite_mask
        move.l graphlib::plane1,a1
        move.w #1,graphlib::choosescreen
        move.l #pic2,a0
        jsr graphlib::put_sprite_mask
        clr.w graphlib::choosescreen


restart move.l #LCD_MEM,a0
        move.l #save_screen,a1
        bsr copy_screen
        move.l graphlib::plane1,a0
        move.l #save_plane1,a1
        bsr copy_screen


disp_sel:

        clr.b option_13+10
        clr.b option_14+10 
        clr.b option_16+10
        move.l #option_21+10,a0
        moveq #4,d0
\loopm1 clr.b (a0)
        lea 11(a0),a0
        dbra d0,\loopm1

        tst.w sel_on
        bne \apres

        move.b #1,option_13+10
        move.b #1,option_14+10 
        move.b #1,option_16+10
        move.l #option_21+10,a0
        moveq #4,d0
\loopm2 move.b #1,(a0)
        lea 11(a0),a0
        dbra d0,\loopm2

\apres  move.l room_data,a0
        cmp.w #99,(a0)
        bne \passe
        move.b #1,option_21+10
\passe  cmp.w #1,(a0)
        bne \apres2
        move.b #1,option_22+10
\apres2 move.l #save_screen,a0
        lea LCD_MEM,a1
        bsr copy_screen

        move.l #save_plane1,a0
        move.l graphlib::plane1,a1
        bsr copy_screen


        moveq #1,d7
        move.w #1,d4
        clr.w d0
        clr.w d1
        move.w #159,d2
        move.w #10,d3
\loop1g jsr graphlib::fill
        move.w d3,d5
        move.w d2,d4
        jsr graphlib::frame
        move.w #1,graphlib::choosescreen   
        move.l graphlib::plane1,a1
        move.w #2,d4
        dbra d7,\loop1g
        clr.w graphlib::choosescreen       

        SetFont #1
        WriteStr #1,#2,#4,barre_option

        move.w speed,stop
        move.w sel,d0
        move.l #option_table,a0
        mulu #2,d0
        move.w 0(a0,d0.w),d3
        mulu #10,d3
        move.w d3,sel_nb
        add.w #8,sel_nb
        move.l #sel_table,a0
        move.w 0(a0,d0.w),d0
        move.w d0,sel_x

        moveq #1,d7

        move.w #10,d1
        move.w #60,d2
        move.w #1,d4

\loop2g jsr graphlib::fill
        move.w d3,d5
        move.w d2,d4
        jsr graphlib::frame
        move.w #1,graphlib::choosescreen   
        move.l graphlib::plane1,a1         
        dbra d7,\loop2g
        clr.w graphlib::choosescreen       



        move.w sel,d0
        mulu #2,d0
        move.l #option_table,a0
        move.w 0(a0,d0.w),d7
        sub.w #1,d7
        mulu #2,d0
        move.l #text_table,a0
        move.l 0(a0,d0.w),a5
        moveq #11,d6
        move.w sel_x,d5
        add.w #3,d5
        
\disp   move.w #4,-(a7)
        tst.b 10(a5)
        beq \normal
        move.w #3,(a7)
\normal move.l a5,-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        add.w #10,d6
        lea 11(a5),a5
        dbra d7,\disp

        move.w #8,sel_y
        bsr invert_sel
sel_loop
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq verifie_sel

        tst.w stop
        beq \apres
        sub.w #1,stop
        bra sel_loop

\apres  move.w #mask0,d0
        bsr get_key
        btst.b #2,d0
        beq down_sel
        btst.b #0,d0
        beq up_sel
        btst.b #1,d0
        beq dec_sel
        btst.b #3,d0
        beq inc_sel
        move.w #mask1,d0
        bsr get_key
        btst.b #0,d0
        beq selection
        bra sel_loop
verifie_sel
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        bne sel_loop
\bon    tst.w sel_on
        beq fin
        lea LCD_MEM,a1
        move.l #save_screen,a0
        bsr copy_screen
        move.l graphlib::plane1,a1
        move.l #save_plane1,a0
        bsr copy_screen
\wait   move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq \wait
        bra main_loop


selection:
        move.w sel_y,d7
        sub.w #8,d7
        divu #10,d7

        cmp.w #3,sel
        beq about

        cmp.w #2,sel
        beq option_sel

        cmp.w #1,sel
        beq room_sel

        tst.w d7
        beq new_file

        cmp.w #2,d7
        beq save_file

        cmp.w #3,d7
        beq rename


        cmp.w #4,d7
        beq find

        cmp.w #5,d7
        beq file_info

        cmp.w #6,d7
        beq fin

        cmp.w #1,d7
        bne sel_loop



load    bsr wait_key_enter_off
        clr.w top
        clr.w cur
redrawf move.w #8,currentfolder
drawf   bsr ini_box
        move.w currentfolder,d0
        DEREF d0,a0
        move.w 2(a0),nbre
        tst.w nbre
        beq passe
        move.w 2(a0),d0
        lea 4(a0),a0
        sub.w #1,d0
        move.l #list,a1
\loop   move.l a0,(a1)+
        lea 14(a0),a0
        dbra d0,\loop
revient move.l #list,a5
        move.w top,d0
        lsl.l #2,d0
        add.w d0,a5
        move.w nbre,d7
        sub.w #1,d7
        cmp.w #4,d7
        ble \bon
        move.w #4,d7
\bon    move.w #40,d5
        move.w #32,d6
\loopd7 move.w #4,-(a7)
        move.l (a5),-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        add.l #4,a5
        add.w #8,d6
        dbra d7,\loopd7
passe   bsr invert

wait_loop
        tst.w stop
        beq \jump
        sub.w #1,stop
        bra wait_loop

\jump   move.w #20000,stop
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq quit
        clr.w stop
        tst.w nbre
        beq wait_loop
        move.w #20000,stop
        move.w #mask1,d0
        bsr get_key
        btst.b #0,d0
        beq choose
        move.w #mask0,d0
        bsr get_key
        btst.b #0,d0
        beq fhaut
        btst.b #2,d0
        beq fbas
        clr.w stop
        bra wait_loop

fbas    move.w nbre,d0
        move.w cur,d1
        add.w top,d1
        add.w #1,d1
        cmp.w d1,d0
        beq wait_loop
        cmp.w #4,cur
        beq fscroll_bas
        bsr invert
        add.w #1,cur
        bsr invert
        bra wait_loop
fscroll_bas:
        add.w #1,top
        bsr ini_box
        bra revient
fhaut   tst.w cur
        beq fscroll_haut
        bsr invert
        sub.w #1,cur
        bsr invert
        bra wait_loop
fscroll_haut
        tst.w top
        beq wait_loop
        sub.w #1,top
        bsr ini_box
        bra revient
choose  bsr wait_key_enter_off
        move.w top,d0
        add.w cur,d0
        lsl.l #2,d0
        move.l #list,a0
        add.w d0,a0
        move.l (a0),a0

        cmp.w #8,currentfolder
        bne enter_file

        move.w 12(a0),d0
        move.w d0,currentfolder
        move.l cur,old_cur
        clr.w top
        clr.w cur
        DEREF d0,a0
        lea 2(a0),a0
        move.w (a0)+,d7
        tst.w d7
        beq drawf
        move.l #list,a5
        sub.w #1,d7
        clr.w nbre
\loop   move.w 12(a0),d0
        DEREF d0,a1
        cmp.l #'CyBx',2(a1)
        bne \apres
        move.l a0,(a5)+
        add.w #1,nbre
\apres  lea 14(a0),a0
        dbra d7,\loop
        bsr ini_box
        tst.w nbre
        bne revient
        bra passe

enter_file
        move.l #name,a1
        move.l 4(a0),4(a1)
        move.l (a0),(a1)
        clr.b 8(a1)
        clr.w stop
        bra found

quit    bsr wait_key_esc_off
        cmp.w #8,currentfolder
        beq disp_sel
        move.l old_cur,cur
        bra redrawf


invert  move.w cur,d1
        mulu #8,d1
        add.w #31,d1
        move.w #31,d0
        move.w #98,d2
        move.w #8,d3
        clr.w d4
        jsr graphlib::fill
        move.w cur,d0
        add.w top,d0
        move.l #list,a0
        lsl.l #2,d0
        move.l 0(a0,d0.w),a0
        move.w 12(a0),d0
        DEREF d0,a0
        cmp.l #'CyBx',2(a0)
        beq \passe
        move.l #open_str+4,-(a7)
        bra \apres
\passe  lea 6(a0),a0
        move.l a0,-(a7)
\apres  jsr doorsos::ST_showHelp
        lea 4(a7),a7
        rts


ini_box moveq #1,d7
\box    move.w #30,d0
        move.w #20,d1
        move.w #100,d2
        move.w #52,d3
        move.w #1,d4
        jsr graphlib::fill
        move.w d3,d5
        move.w d2,d4
        jsr graphlib::frame
        move.w #30,d0
        move.w #30,d1
        move.w #130,d2
        move.w #2,d3
        jsr graphlib::horiz
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        dbra d7,\box
        clr.w graphlib::choosescreen
        WriteStr #67,#22,#4,open_str
        rts


rename  tst.w sel_on
        beq sel_loop
        WriteStr #0,#85,#4,enter_new_str
        move.w #90,d5
        move.w #85,d6
        move.w #8,d7
        move.w d7,d4
        move.l #big_str,a5
        bsr string
        tst.w d0
        beq disp_sel

        jsr graphlib::gray2
        bsr int_off

        move.l vat,a0
        move.w 12(a0),d2
        jsr filelib::hdltoindex
        move.l #big_str,a0
        jsr filelib::rename

        bsr int_on
        jsr graphlib::gray4

        bra disp_sel
                        

save_file:
        tst.w sel_on
        beq sel_loop
        bsr compress
        bra disp_sel

room_sel
        tst.w sel_on
        beq sel_loop
        cmp.w #2,d7
        beq clear_room
        cmp.w #4,d7
        beq room_info
        cmp.w #3,d7
        beq exec_room
        tst.w d7
        beq add_room
        cmp.w #1,d7
        beq del_room
        bra sel_loop

clear_room
        move.l #room+18,a0
        move.w #9,d6
\loopd6 move.w #14,d7
\loopd7 clr.b (a0)+
        dbra d7,\loopd7
        lea 2(a0),a0
        dbra d6,\loopd6
        move.l #room+178,a0
        move.b #15,(a0)
        move.l #str,a0
        moveq #18,d0
\loop   move.b #' ',(a0)+
        dbra d0,\loop
        bsr clrscr
        bsr ini_screen
        bra main_loop

room_info
        moveq #1,d7
\loop3g clr.w d0
        moveq #60,d1
        move.w #159,d2
        moveq #30,d3
        moveq #1,d4
        jsr graphlib::fill
        move.w d2,d4
        move.w d3,d5
        jsr graphlib::frame
        move.l graphlib::plane1,a1
        move.w #1,graphlib::choosescreen
        dbra.s d7,\loop3g
        clr.w graphlib::choosescreen
        move.w #4,-(a7)
        pea.l new_desc(pc)
        move.w #62,-(a7)
        move.w #15,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7

        moveq #2,d5
        moveq #78,d6
        moveq #19,d7
        move.w d7,d4
        move.l #big_str,a5
        bsr string
        tst.w d0
        beq disp_sel
        move.l #save_plane1,a0
        move.l graphlib::plane1,a1
        bsr copy_screen
        move.l #save_screen,a0
        lea LCD_MEM,a1
        bsr copy_screen
        moveq #74,d0
        clr.w d1
        moveq #86,d2
        moveq #6,d3
        moveq #1,d4
        jsr graphlib::fill
        clr.w -(a7)
        jsr doorsos::FontSetSys

        move.l #big_str,a0
        move.l #str,a1
        moveq #18,d0
\mloop  move.b (a0)+,(a1)+
        dbra.s d0,\mloop
        move.w #4,-(a7)
        move.l #str,-(a7)
        clr.w -(a7)
        move.w #74,-(a7)
        jsr doorsos::DrawStrXY
        lea 12(a7),a7
        bra main_loop

file_info
        tst.w sel_on
        beq sel_loop
        moveq #1,d7
\loop3g clr.w d0
        moveq #60,d1
        move.w #159,d2
        moveq #30,d3
        moveq #1,d4
        jsr graphlib::fill
        move.w d2,d4
        move.w d3,d5
        jsr graphlib::frame
        move.l graphlib::plane1,a1
        move.w #1,graphlib::choosescreen
        dbra.s d7,\loop3g
        clr.w graphlib::choosescreen

        move.w #4,-(a7)
        pea.l new_desc(pc)
        move.w #62,-(a7)
        move.w #15,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        
        moveq #2,d5
        moveq #78,d6
        moveq #26,d7
        move.w d7,d4
        move.l #big_str,a5
        bsr string
        tst.w d0
        beq disp_sel
        move.l #big_str,a0
        move.l room_data,a1
        sub.l #32,a1
        moveq #28,d0
\mloop  move.b (a0)+,(a1)+
        dbra.s d0,\mloop
        bra disp_sel
option_sel
        cmp.w #2,d7
        beq.s inc_cont
        cmp.W #3,d7       
        beq.s dec_cont
        tst.w d7
        beq.s inc_speed
        add.w #100,speed
        bra.s retour2
inc_speed
        sub.w #100,speed
        bne.s retour2
        add.w #100,speed
retour2 move.w speed,stop
        bra sel_loop
inc_cont
        moveq #9,d0
        bra.s do_it
dec_cont
        moveq #10,d0
do_it   trap #9
        jsr (a0)
        bra retour2

add_room
        move.l room_data,a0
        cmp.w #99,(a0)
        bge sel_loop
        move.l vat,a0
        move.w 12(a0),d0
        DEREF d0,a1
        move.w (a1),d0
        add.w #95,d0
        jsr filelib::resizefile
        move.l a0,vat
        move.w 12(a0),d0
        DEREF d0,a0
        move.w (a0),d0
        move.l a0,room_data
        add.l #38,room_data
        add.w #1,38(a0)
        move.w 38(a0),40(a0)
        add.w d0,a0
        sub.l #95,a0
        move.l a0,-(a7)
        move.w #94,d1
\loopd1 clr.b (a0)+
        dbra d1,\loopd1
        move.l (a7)+,a0
        or.b #%11110000,20+71(a0)
        lea 95(a0),a0
        move.b #$2d,1(a0)
        bsr clrscr
        bra new_room

del_room
        tst.b option_22+10
        bne sel_loop
        move.l room_data,a0
        move.w 2(a0),room_nb
        move.l vat,a0
        move.w 12(a0),d0
        DEREF d0,a1
        move.w 38(a1),d1
        cmp.w 40(a1),d1
        bne \passe
        sub.w #1,40(a1)
\passe  cmp.w 42(a1),d1
        bne \apres
        sub.w #1,42(a1)
\apres  sub.w #1,38(a1)
        add.l #43,a1
        move.w room_nb,d0
        sub.w #1,d0
        mulu #95,d0
        add.w d0,a1
        move.w room_nb,d0
        sub.w d0,d1
        tst.w d1
        beq \inutil
        sub.w #1,d1
\loopd1 move.w #94,d0
\loopd0 move.b 95(a1),(a1)
        add.l #1,a1
        dbra d0,\loopd0
        dbra d1,\loopd1
\inutil move.b #$2d,2(a1)
        move.l vat,a0
        move.w 12(a0),d0
        DEREF d0,a1
        move.w (a1),d0
        sub.w #95,d0
        jsr filelib::resizefile
        bsr clrscr
        bra new_room

new_file
        WriteStr #0,#85,#4,enter_name_str
        move.w #68,d5
        move.w #85,d6
        move.w #8,d7
        move.w d7,d4
        move.l #big_str,a5
        bsr string
        tst.w d0
        beq disp_sel
        move.l #name,a0
        move.l #big_str,a1
        move.l (a1),(a0)
        move.l 4(a1),4(a0)
        clr.b 8(a0)
        move.w #1,room_nb
write  
        move.l #number_str+17,a0
        clr.l d0
        move.w room_nb,d0
        divu #10,d0
        add.b #48,d0
        move.b d0,(a0)+
        swap d0
        divu #10,d0
        add.b #48,d0
        move.b d0,(a0)
        WriteStr #0,#85,#4,number_str
nloop   tst.w stop
        beq \apres
        sub.w #1,stop
        bra nloop
\apres  move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq verifie_esc
        move.w #mask1,d0
        bsr get_key
        btst.b #0,d0
        beq cbon
        move.w #mask0,d0
        bsr get_key
        btst.b #3,d0
        beq p1
        btst.b #1,d0
        beq m1
        bra nloop
p1      move.w #5000,stop
        add.w #1,room_nb
        cmp.w #99,room_nb
        ble write
        move.w #99,room_nb
        bra write
m1      move.w #5000,stop
        sub.w #1,room_nb
        cmp.w #1,room_nb
        bge write
        move.w #1,room_nb
        bra write
verifie_esc
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        bne nloop
        bra disp_sel

cbon    move.l #name,a0
        move.w #9,d0
        jsr filelib::createfile
        move.w room_nb,d0
        mulu #95,d0
        add.w #44,d0
        jsr filelib::resizefile
        move.l a0,vat
        move.w 12(a0),d0
        DEREF d0,a0
        lea 2(a0),a0
        move.l #'CyBx',(a0)+
        clr.b (a0)
        lea 32(a0),a0
        move.l a0,room_data
        move.w room_nb,(a0)+
        move.w #1,(a0)+
        move.w #1,(a0)+
        move.w room_nb,d7
        sub.w #1,d7
\loop   move.l a0,-(a7)
        move.w #94,d0
\loopd0 clr.b (a0)+
        dbra d0,\loopd0
        move.l (a7)+,a0
        or.b #%11110000,20+71(a0)
        lea 95(a0),a0
        dbra d7,\loop
        move.b #$2d,1(a0)
        bsr clrscr
        move.w #1,sel_on
        bra new_room
        
        

find    move.w #4,-(a7)
        pea.l enter_name_str(pc)
        move.w #85,-(a7)
        clr.w -(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        moveq #68,d5
        moveq #85,d6
        moveq #8,d7
        move.w d7,d4
        move.l #big_str,a5
        bsr string
        tst.w d0
        beq disp_sel

        move.l #name,a0
        move.l #big_str,a1
        move.l (a1),(a0)
        move.l 4(a1),4(a0)
        clr.b 8(a0)

        jsr filelib::search
        tst.w d0
        beq nofound
        bsr wait_key_enter_off

found   move.l a0,vat
        move.w 12(a0),d0
        doorsos::DEREF d0,a0
        cmp.l #'CyBx',2(a0)
        bne wrongformat
        lea 38(a0),a0
        move.l a0,room_data
        bra start_editor

nofound move.w #4,-(a7)
        pea.l cantfind(pc)
        move.w #85,-(a7)
        clr.w -(a7)
        jsr doorsos::DrawStrXY
        move.w #4,-(a7)
        move.l #name,-(a7)
        move.w #85,-(a7)
        move.w #68,-(a7)
        jsr doorsos::DrawStrXY
        lea 20(a7),a7
        bsr wait
        bra disp_sel
wrongformat
        move.w #4,-(a7)
        pea.l format_str(pc)
        move.w #85,-(a7)
        clr.w -(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        bsr wait
        bra disp_sel


string  movem.l d0-d7/a0-a6,-(a7)
        jsr graphlib::gray2
        bsr int_off
        jsr graphlib::gray4
        movem.l (a7)+,d0-d7/a0-a6
        bsr take_string
        move.w d0,-(a7)
        jsr graphlib::gray2
        bsr int_on
        jsr graphlib::gray4
        bsr wait_key_enter_off
        bsr wait_key_esc_off
        move.w (a7)+,d0
        rts

dec_sel tst.w sel
        beq \passe
        sub.w #1,sel
        bra disp_sel
\passe  move.w #3,sel
        bra disp_sel
inc_sel cmp.w #3,sel
        beq \revient
        add.w #1,sel
        bra disp_sel
\revient clr.w sel
        bra disp_sel

down_sel
        bsr invert_sel
        add.w #10,sel_y
        move.w sel_nb,d0
        cmp.W sel_y,d0
        bne ps
        move.w #8,sel_y
ps      bsr invert_sel
        move.w speed,stop
        bra sel_loop
up_sel  bsr invert_sel
        sub.w #10,sel_y
        cmp.w #-2,sel_y
        bne ps
        move.w sel_nb,sel_y
        sub.w #10,sel_y
        bra ps

invert_sel
        move.w sel_y,d1
        add.w #3,d1
        move.w sel_x,d0
        add.w #1,d0
        move.w #58,d2
        move.w #8,d3
        move.w #0,d4
        jsr graphlib::fill
        rts

wait    move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq wait_key_esc_off
        move.w #mask1,d0
        bsr get_key
        btst.b #0,d0
        bne wait
                              
wait_key_enter_off:          ; wait until ENTER is not pressed
        move.w #mask1,d0
        bsr get_key
        btst.b #0,d0
        beq wait_key_enter_off
        rts
wait_key_esc_off:            ; wait until ENTER is not pressed
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq wait_key_esc_off
        rts

about   move.w #1,graphlib::choosescreen   ;
        move.l graphlib::plane1,a1         ;
        move.w #25,d0
        move.w #20,d1
        move.w #111,d2
        move.w #61,d3
        move.w #2,d4
        jsr graphlib::fill
        clr.w graphlib::choosescreen
        lea.l about_str(pc),a0
        jsr graphlib::smallbox
        clr.w -(a7)
        jsr doorsos::FontSetSys   ;2
        move.w #4,-(a7)
        pea.l title(pc)
        move.w #40,-(a7)
        move.w #42,-(a7)
        jsr doorsos::DrawStrXY    ;10
        move.w #4,-(a7)
        pea.l author(pc)
        move.w #52,-(a7)
        move.w #42,-(a7)
        jsr doorsos::DrawStrXY    ;10
        move.w #4,-(a7)
        pea.l email(pc)
        move.w #70,-(a7)
        move.w #31,-(a7)
        jsr doorsos::DrawStrXY
        move.w #4,-(a7)
        pea.l copyright(pc)
        move.w #60,-(a7)
        move.w #65,-(a7)
        jsr doorsos::DrawStrXY
        lea 42(a7),a7
        bsr wait_key_enter_off
        bsr wait
        bsr wait_key_enter_off
        bsr wait_key_esc_off
        bra disp_sel


exec_room:
        bsr compress
        move.w pos,stop
        jsr graphlib::gray2
        bsr int_off
        jsr graphlib::gray4
xstart bsr clrscr
        bsr ini_lvl
        bsr ini_screen
        clr.b dir
        move.w #178,pos

exec_loop:
        bsr xcheck_pushers
        bsr xget_key
        cmp.w #264,d0
        beq fin_exec
        cmp.w #340,d0
        beq xbas
        cmp.w #337,d0
        beq xhaut
        cmp.W #344,d0
        beq xdroite
        cmp.w #338,d0
        beq xgauche
        cmp.w #263,d0
        beq xstart

        cmp.w #257,d0
        beq xundo
        bra exec_loop

xbas    move.b #2,dir
        bra.s xcheck
xhaut   cmp.w #25,pos
        beq fin_exec
        move.b #0,dir
        bra.s xcheck
xdroite move.b #1,dir
        bra.s xcheck
xgauche move.b #3,dir

xcheck
        bsr save_board
        bsr copy_level         ; on met les donnes de level dans save
        move.l #save,a0        ; maintenat on peut travailler a partir de save
        add.w pos,a0           ; on ajoute la position
        move.l a0,update+2     ; la position d'origine est sauvee
        move.l #table,a1
        clr.l d1
        clr.l d7
        move.b dir,d1
        mulu #2,d1
        add.l d1,a1            
        move.w (a1),d7         ; d7=update des mouvements (-17,1,17,-1)
        move.w d7,update       ; on sauve d7
        move.b 0(a0,d7.w),d0   ; d0= valeur de la case ou on veut aller
        cmp.B #20,d0           ; si = 20: on peut pas y aller
        beq exec_loop
        cmp.b #13,d0           ; si = 13: on va sur le selector
        beq selector
        cmp.b #4,d0            ; si = 04: on ne peut pas franchir le mur
        beq exec_loop
        cmp.b #14,d0           ; si = 14: on ne peut pas le bouger directement
        beq exec_loop          
        cmp.b #2,d0
        beq move1
        cmp.b #1,d0
        beq move2
        cmp.b #3,d0
        beq move3
        tst.b d0               ; si = 00:pas de probleme
        beq rien
        cmp.b #5,d0
        blt exec_loop

type9   cmp.b #9,d0
        bge exec_loop
        sub.b #5,d0
        cmp.b dir,d0
        bne exec_loop
        move.l update+2,a1
        cmp.b #15,(a1)
        bne exec_loop
        lsl.w #1,d7
        add.w d7,a1
        tst.b (a1)
        bne exec_loop

rien    move.b #15,0(a0,d7.w)
rienap  add.w d7,pos
        move.l update+2,a0
        cmp.b #16,(a0)
        beq \autre
        clr.b (a0)
        bsr redraw
        bra exec_loop
\autre  move.b #13,(a0)
        bsr redraw
        bra exec_loop
selector:
        move.b #16,0(a0,d7.w)
        bra rienap

move1   move.b dir,d0
        lsr.b #1,d0
        bcc exec_loop
        move.l update+2,a0
        move.w update,d0
        add.w d0,a0          ; position de la borne
        clr.l d7
loop    add.w #1,d7
        add.w d0,a0
        cmp.b #2,(a0)
        beq loop
        cmp.b #3,(a0)
        beq loop
        cmp.b #14,(a0)
        beq loop
        cmp.b #13,(a0)
        beq loop
        tst.b (a0)
        bne exec_loop
meme    move.l a0,a1
        sub.w d0,a1
cyloop  move.b (a1),(a0)
        sub.w d0,a0
        sub.w d0,a1
        dbra d7,cyloop
        move.w update,d7
        bra rien

move2   move.b dir,d0
        lsr.b #1,d0
        bcs exec_loop ; bonne direction
        move.l update+2,a0
        move.w update,d0
        add.w d0,a0          ; position de la borne
        clr.l d7
loop2   add.w #1,d7
        add.w d0,a0
        cmp.b #1,(a0)
        beq loop2
        cmp.b #3,(a0)
        beq loop2
        cmp.b #14,(a0)
        beq loop2
        cmp.b #13,(a0)
        beq loop2
        cmp.b #0,(a0)
        bne exec_loop
        bra meme
move3   move.b dir,d0
        lsr.b #1,d0
        bcs move1
        bra move2


xcheck_pushers:
        bsr copy_level
        move.l #save,a6
        move.w #187,d7
cklp    add.l #1,a6
        sub.w #1,d7
        beq redraw
        cmp.b #9,(a6)
        beq pusher1
        cmp.B #10,(a6)
        beq pusher2
        cmp.b #11,(a6)
        beq pusher3
        cmp.b #12,(a6)
        beq pusher4
        bra cklp
pusher1 move.w #-17,d0
        bra made1
pusher2 move.w #1,d0
        bra made2
pusher3 move.w #17,d0
        bra made1
pusher4 move.w #-1,d0
        bra made2
made1   move.l a6,a5
        clr.w d1
xsearch add.w #1,d1
        add.w d0,a5
        cmp.b #1,(a5)
        beq xsearch
        cmp.b #3,(a5)
        beq xsearch
        cmp.b #14,(a5)
        beq xsearch
        cmp.b #13,(a5)
        beq xsearch
        cmp.B #20,(a5)
        beq cklp
        cmp.b #0,(a5)
        bne cklp
same    move.l a5,a4
        sub.w d0,a4
loop7   move.b (a4),(a5)
        sub.w d0,a5
        sub.w d0,a4
        dbra d1,loop7
        clr.b (a6)
        bra redraw
made2   move.l a6,a5
        clr.w d1
search2 add.w #1,d1
        add.w d0,a5
        cmp.b #2,(a5)
        beq search2
        cmp.b #3,(a5)
        beq search2
        cmp.b #14,(a5)
        beq search2
        cmp.b #13,(a5)
        beq search2
        cmp.B #20,(a5)
        beq cklp
        cmp.b #0,(a5)
        bne cklp
        bra same

xundo   bsr copy_board
        clr.w d0
        move.l #save,a0
\loop   add.w #1,d0
        add.l #1,a0
        cmp.b #15,(a0)
        beq \bon
        cmp.b #16,(a0)
        bne \loop
\bon    move.w d0,pos
        bsr redraw
        bra exec_loop
        
xget_key tst.w (doorsos::kb_vars+$1C)
        beq exit
        move.w (doorsos::MaxHandles+$1E),d0
        clr.w (doorsos::kb_vars+$1C)
        rts
        
fin_exec
        jsr graphlib::gray2
        bsr int_on
        jsr graphlib::gray4
        move.w stop,pos
        bra new_room
        

start_editor
        bsr clrscr
        move.w #1,sel_on

new_room
        bsr ini_lvl
        bsr ini_screen
        clr.b dir
        move.w #178,pos
        bsr inv_cursor

main_loop:
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq verifie

        tst.w stop
        beq \apres
        sub.W #1,stop
        bra main_loop
\apres  move.w #mask0,d0
        bsr get_key
        btst.b #3,d0
        beq droite
        btst.b #1,d0
        beq gauche
        btst.b #2,d0
        beq bas
        btst.b #0,d0
        beq haut

        btst.b #4,d0
        beq second
        btst.b #5,d0
        beq shift
        btst.b #6,d0
        beq diamond
        btst.b #7,d0
        beq alpha

        move.w #mask3,d0
        bsr get_key
        btst.b #6,d0
        beq change_mode

        move.w #mask1,d0
        bsr get_key
        btst.b #6,d0
        beq new_room
        btst.b #1,d0
        beq plus
        btst.b #2,d0
        beq moins


        bra main_loop

verifie move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        bne main_loop
        bsr wait_key_esc_off
        bra restart

change_mode
        bsr inv_cursor
        clr.w d0
        moveq #89,d1
        move.w #136,d4
        moveq #10,d5
        jsr graphlib::frame
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        jsr graphlib::frame
        clr.w graphlib::choosescreen
        clr.w d4
        moveq #1,d0
        moveq #90,d1
        moveq #14,d7
\loop   move.w d4,d2
        bsr put_sprite
        add.w #1,d4
        add.w #9,d0
        dbra.s d7,\loop

        move.w pos,update
        move.w #178,pos
        bsr inv_cursor
choose_loop
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        beq no_change

        tst.w stop
        beq \bon
        sub.w #1,stop
        bra choose_loop
\bon    move.w #mask0,d0
        bsr get_key
        btst.b #1,d0
        beq left
        btst.B #3,d0
        beq right

        btst.b #4,d0
        beq choosesecond
        btst.b #5,d0
        beq chooseshift
        btst.b #6,d0
        beq choosediamond
        btst.B #7,d0
        beq choosealpha
        bra choose_loop

plus    bsr compress
        move.l room_data,a0
        move.w (a0),d0
        cmp.w 2(a0),d0
        ble new_room
        add.w #1,2(a0)
        bra new_room
moins   bsr compress
        move.l room_data,a0
        sub.w #1,2(a0)
        bne new_room
        add.w #1,2(a0)
        bra new_room

choosesecond
        move.l #select,a0
        bra.S put_value
chooseshift
        move.l #select+2,a0
        bra.S put_value
choosediamond
        move.l #select+4,a0
        bra.S put_value
choosealpha
        move.l #select+6,a0
put_value:
        clr.l d0
        move.w pos,d0
        sub.w #171,d0
        move.w d0,(a0)
        bra exit_change

left    bsr inv_cursor
        cmp.w #171,pos
        beq \passg
        sub.W #1,pos
        bra pass2g
\passg  move.w #185,pos
pass2g  bsr inv_cursor
        move.w speed,stop
        bra choose_loop
right   bsr inv_cursor
        cmp.w #185,pos
        beq \passd
        add.w #1,pos
        bra pass2g
\passd  move.w #171,pos
        bra pass2g

no_change:
        move.w #mask6,d0
        bsr get_key
        btst.b #0,d0
        bne choose_loop
        bsr wait_key_esc_off
exit_change
        move.w update,pos
        bsr ini_screen
        bsr inv_cursor
        bra main_loop


second  move.w select,stop
        bra.s put_objet
shift   move.w select+2,stop
        bra.s put_objet
diamond move.w select+4,stop
        bra.s put_objet
alpha   move.w select+6,stop

put_objet:
        bsr copy_level
        move.l #save,a0
        add.w pos,a0
        cmp.b #15,(a0)
        beq main_loop
        bsr inv_cursor
        clr.l d0
        move.w stop,d0
        move.b d0,(a0)
        bsr redraw
        bsr inv_cursor
        bra main_loop

haut    clr.b dir
        bra move_cursor
bas     move.b #2,dir
        bra move_cursor
gauche  move.b #3,dir
        bra move_cursor
droite  move.b #1,dir        
move_cursor
        move.l #room,a0
        add.w pos,a0
        move.l #table,a1
        clr.l d0
        move.b dir,d0
        mulu #2,d0
        add.w d0,a1
        move.w (a1),update
        add.w (a1),a0
        cmp.b #20,(a0)
        bne \pasbon
        move.w 8(a1),update
\pasbon bsr inv_cursor
        move.w update,d0
        add.w d0,pos
        bsr inv_cursor
        move.w speed,stop
        bra main_loop
        
fin     bsr wait_key_enter_off
        bsr clrscr
        jsr graphlib::gray2
        bsr int_off
exit    rts


ini_lvl move.l room_data,a0       ; met les donnes du level dans room
        clr.l d0
        move.w 2(a0),d0
        sub.l #89,a0
        mulu #95,d0
        add.l d0,a0
        move.l #str,a1
        moveq #19,d0
\loop   move.b (a0)+,(a1)+
        dbra d0,\loop
        move.l #save,a1
        bclr.b #0,d7
        clr.l d2
        move.w #203,d0
\loop1  move.b (a0)+,d2
        btst.b #0,d7
        bne \saute
        ror.b #4,d2
        sub.l #1,a0
\saute  and.b #%00001111,d2
        move.b d2,(a1)+
        bchg.b #0,d7
        dbra d0,\loop1
        move.l #save,a0
        move.l #room+18,a1
        moveq #9,d1
\loop2  moveq #14,d0
\loop3  move.b (a0)+,(a1)+
        dbra d0,\loop3
        lea 2(a1),a1
        dbra d1,\loop2
        rts

compress:
        move.l room_data,a0       ; met les donnes du level dans room
        clr.l d0
        move.w 2(a0),d0
        sub.l #89,a0
        mulu #95,d0
        add.l d0,a0            ; on remet la description
        move.l #str,a1         ;
        moveq #19,d0           ;
\loop   move.b (a1)+,(a0)+     ;
        dbra d0,\loop
        move.l a0,update+2
        move.l #room+18,a1
        move.l #save,a2
        move.w #9,d6
\loop2  move.w #14,d7
\loop1  move.B (a1)+,(a2)+
        dbra d7,\loop1
        lea 2(a1),a1
        dbra d6,\loop2
        move.l #save,a1
        move.w #74,d0
\loop3  move.b (a1)+,d2
        rol.b #4,d2
        and.b #%11110000,d2
        move.b (a1)+,d3
        and.b #%00001111,d3
        or.b d3,d2
        move.b d2,(a0)+
        dbra d0,\loop3
        rts

ini_screen:
        move.l #room+18,a5
        move.w #1,d0
        move.w #9,d1
        move.w #9,d6
loopd6  move.w #14,d7
loopd7  clr.l d2
        move.b (a5)+,d2
        bsr put_sprite
        add.w #9,d0
        dbra d7,loopd7
        move.w #1,d0
        add.w #9,d1
        lea 2(a5),a5
        dbra d6,loopd6
        move.w #0,d0
        move.w #8,d1
        move.w #136,d4
        move.W #91,d5
        jsr graphlib::frame
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        move.w #0,d0
        move.w #8,d1
        move.w #136,d4
        move.W #91,d5
        jsr graphlib::frame
        clr.w graphlib::choosescreen
        move.w #64,d0
        move.w #1,d1
        move.w #17,d2
        bsr put_sprite
        move.w #75,d0
        move.w #0,d1
        move.w #160-75,d2
        move.w #6,d3
        move.w #1,d4
        jsr graphlib::fill
        SetFont #0
        WriteStr #75,#0,#4,str
        move.l #room_str+5,a0
        clr.l d0
        move.l room_data,a1
        move.w 2(a1),d0
        divu #10,d0
        add.b #48,d0
        move.b d0,(a0)+
        swap d0
        divu #10,d0
        add.b #48,d0
        move.B d0,(a0)
        WriteStr #0,#0,#4,room_str
        move.w #140,d0
        moveq #10,d4
        moveq #10,d5
        moveq #3,d7
        move.l #select,a6
        clr.w d1
        clr.w d2
\disp   add.w #20,d1
        jsr graphlib::frame
        move.w (a6)+,d2
        add.w #1,d1
        add.w #1,d0
        bsr put_sprite
        sub.W #1,d1
        sub.w #1,d0
        dbra d7,\disp
        rts

redraw  move.l #room+18,a5
        move.l #save+18,a6
        move.w #1,d0
        move.w #9,d1
        move.w #9,d6
rloop1  move.w #14,d7
rloop2  clr.l d2
        move.b (a6),d2
        cmp.b (a5),d2
        bne change
retour  add.l #1,a5
        add.l #1,a6
        add.w #9,d0
        dbra d7,rloop2
        move.w #1,d0
        add.w #9,d1
        lea 2(a5),a5
        lea 2(a6),a6
        dbra d6,rloop1
        bsr copy_save
        rts
change  bsr put_sprite
        bra retour


put_sprite:
        move.l #mask,a2
        move.l #sprite,a0
        mulu #22,d2
        add.l d2,a0
        jsr graphlib::put_sprite2
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        move.l #mask,a2
        move.l #plane1,a0
        add.l d2,a0
        jsr graphlib::put_sprite2
        clr.w graphlib::choosescreen
        rts

clrscr  jsr graphlib::clr_scr
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        jsr graphlib::clr_scr
        clr.w graphlib::choosescreen
        rts

copy_level:
        move.l #save,a1
        move.l #room,a0
memechose:
        move.w #203,d7
\loop   move.b (a0)+,(a1)+
        dbra.s d7,\loop
        rts
copy_save:
        move.l #save,a0
encore_m_h
        move.l #room,a1
        bra.s memechose
copy_board:
        move.l #board,a0
        move.l #save,a1
        bra.s memechose
save_board:
        move.l #room,a0
        move.l #board,a1
        bra.s memechose




copy_screen
        moveq.w #99,d0
copy_loop
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        move.w (a0)+,(a1)+
        add.l #10,a0
        add.l #10,a1
        dbra.s d0,copy_loop
        rts


inv_cursor:
        clr.l d0
        clr.l d1
        move.w pos,d0
        sub.w #1,d0
        divu #17,d0
        move.w d0,d1
        mulu #9,d1
        swap d0
        mulu #9,d0
        add.w #1,d0
        moveq #8,d2
        moveq #8,d3
        clr.w d4
        jsr graphlib::fill
        rts

ok      clr.w d0
        rts

take_string:
        jsr userlib::idle_loop
        cmp.w #257,d0
        beq.s undo
        cmp.w #264,d0
        beq.s ok
        cmp.w #13,d0
        beq.s \bon
        tst.w d7
        beq take_string
        move.b d0,(a5)+
        move.w #4,-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        move.w d0,-(a7)
        jsr userlib::DrawCharXY
        lea 8(a7),a7
        addq.w #6,d5
        dbra.s d7,take_string
\bon    cmp.w d4,d7
        beq.s take_string
        clr.b (a5)
        rts
undo    cmp.w d4,d7
        beq.s take_string
        addq.w #1,d7
        clr.b -(a5)
        subq.w #6,d5
        move.w #4,-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        move.w #32,-(a7)
        jsr userlib::DrawCharXY
        lea 8(a7),a7
        bra.s take_string


get_key move.w  d0,$600018
        moveq #50,d0
delay_c dbra.s d0,delay_c
        move.b $60001b,d0
        rts

int_on  move.w #$0700,d0
        trap #1
        bclr.b #2,($600001)
        move.l ($64),old_int1
        move.l #new_int,($64)
        bset.b #2,($600001)
        trap #1
	rts
int_off move.w #$0700,d0
        trap #1
        bclr.b #2,($600001)
        move.l old_int1,($64)
        bset.b #2,($600001)
        trap #1
	rts
new_int rte



;sprites:
;
; 00 = vide
; 01 = slider vertical
; 02 = slider horizontal
; 03 = slider multidirectionnel
;
; 04 = blocker
;
; 05 = zapper vers le haut
; 06 = zapper vers la droite
; 07 = zapper vers le bas
; 08 = zapper vers la gauche
;
; 09 = pusher vers le haut
; 10 = pusher vers la droite
; 11 = pusher vers le bas
; 12 = pusher vers la gauche
;
; 13 = selector type1
; 14 = selector type2
;
; 15 = curseur
;
; 16 = selector type1 + curseur
;
; 17 = sortie du level
;
; 18 = mask
;
;
; xx bis = sprite pour le plan2


sprite  dc.w 9                 ; 00
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 01
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000100000000000
        dc.w %0001110000000000
        dc.w %0010101000000000
        dc.w %0000100000000000
        dc.w %0010101000000000
        dc.w %0001110000000000
        dc.w %0000100000000000
        dc.w %0000000000000000

        dc.w 9                 ; 02
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0111111100000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 03
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0000100000000000
        dc.w %0100100100000000
        dc.w %0111111100000000
        dc.w %0100100100000000
        dc.w %0000100000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 9
        dc.w 2                 ; 04
        dc.w %0000000000000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0000000000000000

        dc.w 9                 ; 05
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0101110100000000
        dc.w %0101010100000000
        dc.w %0111111100000000
                               
        dc.w 9                 ;06
        dc.w 2
        dc.w %0000000000000000
        dc.w %1110000000000000
        dc.w %1001100000000000
        dc.w %1110011000000000
        dc.w %1010000100000000
        dc.w %1110011000000000
        dc.w %1001100000000000
        dc.w %1110000000000000
        dc.w %0000000000000000

        dc.w 9                 ;07
        dc.w 2
        dc.w %0111111100000000
        dc.w %0101010100000000
        dc.w %0101110100000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0000000000000000

        dc.w 9                 ; 08
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000001110000000
        dc.w %0000110010000000
        dc.w %0011001110000000
        dc.w %0100001010000000
        dc.w %0011001110000000
        dc.w %0000110010000000
        dc.w %0000001110000000
        dc.w %0000000000000000

        dc.w 9                 ; 09
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0111111100000000

        dc.w 9                 ; 10
        dc.w 2
        dc.w %0000000000000000
        dc.w %1110000000000000
        dc.w %1001100000000000
        dc.w %1000011000000000
        dc.w %1000000100000000
        dc.w %1000011000000000
        dc.w %1001100000000000
        dc.w %1110000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 11
        dc.w 2
        dc.w %0111111100000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0000000000000000

        dc.w 9                 ; 12
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000001110000000
        dc.w %0000110010000000
        dc.w %0011000010000000
        dc.w %0110000010000000
        dc.w %0011000010000000
        dc.w %0000110010000000
        dc.w %0000001110000000
        dc.w %0000000000000000

        dc.w 9                 ; 13
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 14
        dc.w 2
        dc.w %0000000000000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0000000000000000

        dc.w 9                 ; 15
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 9                 ; 16
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 8                 ; 17
        dc.w 2
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %0000000001111111

mask    dc.w %1111111110000000 ; 18      
        dc.w %1111111110000000        
        dc.w %1111111110000000
        dc.w %1111111110000000        
        dc.w %1111111110000000
        dc.w %1111111110000000        
        dc.w %1111111110000000
        dc.w %1111111110000000        
        dc.w %1111111110000000

plane1  dc.w 9                 ; 00 bis
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        
        dc.w 9                 ; 01 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 02 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 03 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 04 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1010101010000000
        dc.w %1101010110000000
        dc.w %1010101010000000
        dc.w %1101010110000000
        dc.w %1010101010000000
        dc.w %1101010110000000
        dc.w %1010101010000000
        dc.w %1111111110000000

        dc.w 9                 ; 05 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000100010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1110001110000000
        dc.w %1110001110000000
        dc.w %1111111110000000

        dc.w 9                 ; 06 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1110000010000000
        dc.w %1111100010000000
        dc.w %1001111010000000
        dc.w %1001111110000000
        dc.w %1001111010000000
        dc.w %1111100010000000
        dc.w %1110000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 07 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1110001110000000
        dc.w %1110001110000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1000100010000000
        dc.w %1111111110000000

        dc.w 9                 ; 08 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000001110000000
        dc.w %1000111110000000
        dc.w %1011110010000000
        dc.w %1111110010000000
        dc.w %1011110010000000
        dc.w %1000111110000000
        dc.w %1000001110000000
        dc.w %1111111110000000

        dc.w 9                 ; 09 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000100010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1111111110000000
        dc.w %1111111110000000
        dc.w %1111111110000000

        dc.w 9                 ; 10 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1110000010000000
        dc.w %1111100010000000
        dc.w %1111111010000000
        dc.w %1111111110000000
        dc.w %1111111010000000
        dc.w %1111100010000000
        dc.w %1110000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 11 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1111111110000000
        dc.w %1111111110000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1000100010000000
        dc.w %1111111110000000

        dc.w 9                 ; 12 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000001110000000
        dc.w %1000111110000000
        dc.w %1011111110000000
        dc.w %1111111110000000
        dc.w %1011111110000000
        dc.w %1000111110000000
        dc.w %1000001110000000
        dc.w %1111111110000000

        dc.w 9                 ; 13 bis
        dc.w 2
        dc.w %1111011110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %0000000000000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111011110000000

        dc.w 9                 ; 14 bis
        dc.w 2
        dc.w %1111011110000000
        dc.w %1100000110000000
        dc.w %1010001010000000
        dc.w %1001010010000000
        dc.w %0000100000000000
        dc.w %1001010010000000
        dc.w %1010001010000000
        dc.w %1100000110000000
        dc.w %1111011110000000

        dc.w 9                 ; 15 bis
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0011111000000000
        dc.w %0111111100000000
        dc.w %0111111100000000
        dc.w %0111111100000000
        dc.w %0011111000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 9                 ; 16 bis
        dc.w 2
        dc.w %1111011110000000
        dc.w %1001110010000000
        dc.w %1011111010000000
        dc.w %1111111110000000
        dc.w %0111111100000000
        dc.w %1111111110000000
        dc.w %1011111010000000
        dc.w %1001110010000000
        dc.w %1111011110000000

        dc.w 8                 ; 17 bis
        dc.w 2
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111111111111


room    dc.b 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20
        dc.b 20,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,20
        dc.b 20,04,04,00,00,00,04,00,04,00,04,04,04,04,00,00,20
        dc.b 20,00,00,01,13,01,00,00,04,00,04,00,00,04,00,04,20
        dc.b 20,05,00,14,04,14,04,00,00,01,00,00,02,13,02,00,20
        dc.b 20,00,08,13,00,13,00,04,00,14,04,04,04,04,00,04,20
        dc.b 20,04,00,00,00,00,00,04,00,13,00,00,02,13,02,00,20
        dc.b 20,00,00,00,00,00,00,04,07,14,04,04,04,04,00,04,20
        dc.b 20,00,00,00,00,00,00,04,00,01,06,00,02,13,02,00,20
        dc.b 20,00,02,02,03,02,00,08,00,00,04,04,07,04,00,04,20
        dc.b 20,00,00,09,00,09,00,04,15,04,04,00,00,00,00,00,20
        dc.b 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20

table     dc.w -17,1,17,-1
          dc.w 17*9,3-17,-17*9,17-3
select    dc.w 10,11,13,14
str       dc.b "1234567890123456789",0
room_str  dc.b "room xx",0

barre_option dc.b "file room option   about",0


option_11 dc.b "new      ",0,0
option_12 dc.b "open     ",0,0
option_13 dc.b "save     ",0,0
option_14 dc.b "rename   ",0,0
option_15 dc.b "search   ",0,0
option_16 dc.b "file info",0,0
option_17 dc.b "exit     ",0,0

option_21 dc.b "add room ",0,0
option_22 dc.b "del room ",0,0
option_23 dc.b "  clear  ",0,0
option_24 dc.b "play room",0,0
option_25 dc.b "room info",0,0

option_31 dc.b "speed",23,"   ",0,0
option_32 dc.b "speed",24,"   ",0,0
option_33 dc.b "contrast",23,0,0
option_34 dc.b "contrast",24,0,0

option_41 dc.b "  about  ",0,0

option_table dc.w 7,5,4,1
sel_table    dc.w 0,30,59,99
text_table   dc.l option_11
             dc.l option_21
             dc.l option_31
             dc.l option_41

enter_name_str dc.b "Enter name:         ",0
enter_new_str  dc.b "enter new name:",0
cantfind       dc.b "can't find ",0
format_str     dc.b "file not valid      ",0
title          dc.b " Cyberbox editor v1.0 ",0
author         dc.b "made by Alban Gervaise",0
copyright      dc.b 169," 1999",0
about_str      dc.b "About",0
email          dc.b "email: GefunS@I-France.com",0
new_desc       dc.b "enter new description",0
number_str     dc.b "number of rooms: xx",0
open_str       dc.b "OPEN",0



_comment dc.B "CyberBox editor v1.0 by Endive!",0

        BSS

save_screen    ds.b 3000
save_plane1    ds.b 3000
save           ds.b 204
board          ds.b 204
list           ds.l 200
big_str        ds.b 32
name           ds.b 9
room_nb        ds.w 1
old_int1       ds.l 1
vat            dc.l 1
currentfolder  ds.w 1
nbre           ds.w 1
cur            dc.w 1
top            ds.w 1
old_cur        ds.w 1
old_top        ds.w 1
update         ds.w 1
               ds.l 1
dir            ds.b 1
pos            ds.w 1
stop           ds.w 1
room_data      ds.l 1
speed          ds.w 1
sel            ds.w 1
sel_x          ds.w 1
sel_y          ds.w 1
sel_nb         ds.w 1
sel_on         ds.w 1


         end

; made by Alban Gervaise
