; CyberBox v1.0 by Alban Gervaise (Endive!)
; last update: 26/01/99


        include "doorsos.h"
        include "userlib.h"
        include "graphlib.h"
        include "box_pic.asm"
        include "filelib.h"
        include "cyber.asm"

        xdef _ti89
        xdef _main
        xdef _comment

        dc.l 'ICON'
        dc.w %0111111101111111
        dc.w %0100000111000001
        dc.w %0100001000100001
        dc.w %0100000001000001
        dc.w %0100000010000001
        dc.w %0100000000000001
        dc.w %0100000010000001
        dc.w %0111111111111111

_main
        jsr graphlib::clr_scr
        jsr graphlib::gray4
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        jsr graphlib::clr_scr
        clr.w graphlib::choosescreen
        move.l #pic1,a0
        move.w #5,d0
        move.w #30,d1
        move.b #%11111111,d3
        jsr graphlib::put_sprite_mask
        move.l graphlib::plane1,a1
        move.w #1,graphlib::choosescreen
        move.l #pic2,a0
        jsr graphlib::put_sprite_mask
        clr.w graphlib::choosescreen
        WriteStr #50,#70,#4,author
        WriteStr #20,#80,#4,email
        jsr userlib::idle_loop
        jsr graphlib::gray2


load    clr.w top
        clr.w pos
redrawf move.w #8,currentfolder
        clr.w -(a7)
        jsr doorsos::ST_busy
        lea 2(a7),a7

drawf   SetFont #1
        bsr ini_box
        move.w currentfolder,d0
        DEREF d0,a0
        move.w 2(a0),nbre
        tst.w nbre
        beq passe
        move.w 2(a0),d0
        lea 4(a0),a0
        sub.w #1,d0
        move.l #list,a1
\loop   move.l a0,(a1)+
        lea 14(a0),a0
        dbra d0,\loop
revient move.l #list,a5
        move.w top,d0
        lsl.l #2,d0
        add.w d0,a5
        move.w nbre,d7
        sub.w #1,d7
        cmp.w #9,d7
        ble \bon
        move.w #9,d7
\bon    move.w #2,d5
        move.w #12,d6
\loopd7 move.w #4,-(a7)
        move.l (a5),-(a7)
        move.w d6,-(a7)
        move.w d5,-(a7)
        jsr doorsos::DrawStrXY
        lea 10(a7),a7
        bsr info
        add.l #4,a5
        add.w #8,d6
        dbra d7,\loopd7
passe   bsr invert

wait_loop
        jsr userlib::idle_loop
        cmp.w #264,d0
        beq quit
        cmp.w #13,d0
        beq choose
        tst.w nbre
        beq wait_loop
        cmp.w #337,d0
        beq fhaut
        cmp.W #340,d0
        beq fbas
        bra wait_loop

fbas    move.w nbre,d0
        move.w pos,d1
        add.w top,d1
        add.w #1,d1
        cmp.w d1,d0
        beq wait_loop
        cmp.w #9,pos
        beq fscroll_bas
        bsr invert
        add.w #1,pos
        bsr invert
        bra wait_loop
fscroll_bas:
        add.w #1,top
        bsr ini_box
        bra revient

fhaut   tst.w pos
        beq fscroll_haut
        bsr invert
        sub.w #1,pos
        bsr invert
        bra wait_loop
fscroll_haut
        tst.w top
        beq wait_loop
        sub.w #1,top
        bsr ini_box
        bra revient

choose  move.l pos,old_pos                
        move.w top,d0
        add.w pos,d0
        lsl.l #2,d0
        move.l #list,a0
        add.w d0,a0
        move.l (a0),a0
        move.w 12(a0),d0
        cmp.w #8,currentfolder
        bne enter_file
        move.w d0,currentfolder
        clr.w top
        clr.w pos
        DEREF d0,a0
        lea 2(a0),a0
        move.w (a0)+,d7
        tst.w d7
        beq drawf
        move.l #list,a5
        sub.w #1,d7
        clr.w nbre
\loop   move.w 12(a0),d0
        DEREF d0,a1
        cmp.l #'CyBx',2(a1)
        bne \apres
        move.l a0,(a5)+
        add.w #1,nbre
\apres  lea 14(a0),a0
        dbra d7,\loop
        bsr ini_box
        tst.w nbre
        bne revient
        bra passe


quit    cmp.w #8,currentfolder
        beq exit
        move.l old_pos,pos
        bra redrawf


invert  move.w pos,d1
        mulu #8,d1
        add.w #12,d1
        move.w #1,d0
        move.w #157,d2
        move.w #8,d3
        clr.w d4
        jsr graphlib::fill
        tst.w nbre
        beq rienf
        move.w pos,d0
        add.w top,d0
        move.l #list,a0
        mulu #4,d0
        add.w d0,a0
        move.l (a0),a0
        move.w 12(a0),d0
        DEREF d0,a0
        cmp.l #'CyBx',2(a0)
        bne efface
        add.l #6,a0
        move.l a0,-(a7)
disp    jsr doorsos::ST_showHelp
        lea 4(a7),a7
        rts
efface move.l #help_str,-(a7)
        bra disp
rienf   move.l #no_room_str,-(a7)
        bra disp

info    movem.l a0-a6/d0-d7,-(a7)
        move.w d6,d0
        sub.w #12,d0
        divu #8,d0
        add.w top,d0
        move.l #list,a0
        lsl.l #2,d0
        move.l 0(a0,d0.w),a0
        move.w 12(a0),d0
        DEREF d0,a0
        cmp.l #'CyBx',2(a0)
        bne \passe
        move.w 38(a0),d0
        move.l #rooms_str,a0
        divu #10,d0
        add.b #48,d0
        move.b d0,(a0)+
        swap d0
        divu #10,d0
        add.b #48,d0
        move.b d0,(a0)
        add.w #1,d6
        WriteStr #100,d6,#4,rooms_str
\passe  movem.l (a7)+,a0-a6/d0-d7
        rts


ini_box move.w #00,d0
        move.w #00,d1
        move.w #159,d2
        move.w #93,d3
        move.w #1,d4
        jsr graphlib::fill
        move.w d3,d5
        move.w d2,d4
        jsr graphlib::frame
        move.w #00,d0
        move.w #00,d1
        move.w #159,d2
        move.w #12,d3
        jsr graphlib::horiz
        WriteStr #2,#2,#4,open_str
        move.w #1,d0
        move.w #1,d1
        move.w #157,d2
        move.w #10,d3
        move.w #0,d4
        jsr graphlib::fill
        rts


enter_file
        tst.w nbre
        beq wait_loop
        DEREF d0,a0
        lea 38(a0),a0
        move.l a0,room_data
        move.w #1,2(a0)

        jsr graphlib::gray4
        jsr graphlib::clr_scr
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        jsr graphlib::clr_scr
        clr.w graphlib::choosescreen

new_room
        bsr ini_lvl
        bsr ini_screen
        clr.b dir
        move.w #178,pos

main_loop:
        bsr check_pushers
        bsr get_key
        cmp.w #264,d0
        beq fin
        cmp.w #340,d0
        beq bas
        cmp.w #337,d0
        beq haut
        cmp.W #344,d0
        beq droite
        cmp.w #338,d0
        beq gauche
        cmp.w #263,d0
        beq new_room
        cmp.w #43,d0
        beq plus
        cmp.w #45,d0
        beq moins
        cmp.w #267,d0
        bne main_loop

        trap #4

;        cmp.w #257,d0
;        beq undo
        bra main_loop

inc_contrast
        moveq #9,d0
        bra apresc
dec_contrast
        moveq #10,d0
apresc  bsr do_cont
        bra main_loop

do_cont trap #9
        jsr (a0)
        rts

fin     jsr graphlib::clr_scr
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        jsr graphlib::clr_scr
        clr.w graphlib::choosescreen
        jsr graphlib::gray2
exit    rts

bas     move.b #2,dir
        bra.s check
haut    cmp.w #25,pos
        beq change_de_room
        move.b #0,dir
        bra.s check
droite  move.b #1,dir
        bra.s check
gauche  move.b #3,dir

check
;        bsr save_board
        bsr copy_level         ; on met les donnes de level dans save
        move.l #save,a0        ; maintenat on peut travailler a partir de save
        add.w pos,a0           ; on ajoute la position
        move.l a0,update+2     ; la position d'origine est sauvee
        move.l #table,a1
        clr.l d1
        clr.l d7
        move.b dir,d1
        mulu #2,d1
        add.l d1,a1            
        move.w (a1),d7         ; d7=update des mouvements (-17,1,17,-1)
        move.w d7,update       ; on sauve d7
        move.b 0(a0,d7.w),d0   ; d0= valeur de la case ou on veut aller
        cmp.B #20,d0           ; si = 20: on peut pas y aller
        beq main_loop
        cmp.b #13,d0           ; si = 13: on va sur le selector
        beq selector
        cmp.b #4,d0            ; si = 04: on ne peut pas franchir le mur
        beq main_loop
        cmp.b #14,d0           ; si = 14: on ne peut pas le bouger directement
        beq main_loop          
        cmp.b #2,d0
        beq move1
        cmp.b #1,d0
        beq move2
        cmp.b #3,d0
        beq move3
        tst.b d0               ; si = 00:pas de probleme
        beq rien
        cmp.b #5,d0
        blt main_loop

type9   cmp.b #9,d0
        bge main_loop
        sub.b #5,d0
        cmp.b dir,d0
        bne main_loop
        move.l update+2,a1
        cmp.b #15,(a1)
        bne main_loop
        lsl.w #1,d7
        add.w d7,a1
        tst.b (a1)
        bne main_loop

rien    move.b #15,0(a0,d7.w)
rienap  add.w d7,pos
        move.l update+2,a0
        cmp.b #16,(a0)
        beq \autre
        clr.b (a0)
        bsr redraw
        bra main_loop
\autre  move.b #13,(a0)
        bsr redraw
        bra main_loop
selector:
        move.b #16,0(a0,d7.w)
        bra rienap

move1   move.b dir,d0
        lsr.b #1,d0
        bcc main_loop ; bonne direction
        move.l update+2,a0
        move.w update,d0
        add.w d0,a0          ; position de la borne
        clr.l d7
loop    add.w #1,d7
        add.w d0,a0
        cmp.b #2,(a0)
        beq loop
        cmp.b #3,(a0)
        beq loop
        cmp.b #14,(a0)
        beq loop
        cmp.b #13,(a0)
        beq loop
        tst.b (a0)
        bne main_loop
meme    move.l a0,a1
        sub.w d0,a1
cyloop  move.b (a1),(a0)
        sub.w d0,a0
        sub.w d0,a1
        dbra d7,cyloop
        move.w update,d7
        bra rien

move2   move.b dir,d0
        lsr.b #1,d0
        bcs main_loop ; bonne direction
        move.l update+2,a0
        move.w update,d0
        add.w d0,a0          ; position de la borne
        clr.l d7
loop2   add.w #1,d7
        add.w d0,a0
        cmp.b #1,(a0)
        beq loop2
        cmp.b #3,(a0)
        beq loop2
        cmp.b #14,(a0)
        beq loop2
        cmp.b #13,(a0)
        beq loop2
        cmp.b #0,(a0)
        bne main_loop
        bra meme
move3   move.b dir,d0
        lsr.b #1,d0
        bcs move1
        bra move2

redraw  move.l #room+18,a5
        move.l #save+18,a6
        move.w #1,d0
        move.w #9,d1
        move.w #9,d6
rloop1  move.w #14,d7
rloop2  clr.l d2
        move.b (a6),d2
        cmp.b (a5),d2
        bne change
retour  add.l #1,a5
        add.l #1,a6
        add.w #9,d0
        dbra d7,rloop2
        move.w #1,d0
        add.w #9,d1
        lea 2(a5),a5
        lea 2(a6),a6
        dbra d6,rloop1
        bsr copy_save
        rts
change  bsr put_sprite
        bra retour

check_pushers:
        bsr copy_level
        move.l #save,a6
        move.w #187,d7
cklp    add.l #1,a6
        sub.w #1,d7
        beq fini
        cmp.b #9,(a6)
        beq pusher1
        cmp.B #10,(a6)
        beq pusher2
        cmp.b #11,(a6)
        beq pusher3
        cmp.b #12,(a6)
        beq pusher4
        bra cklp
pusher1 move.w #-17,d0
        bra made1
pusher2 move.w #1,d0
        bra made2
pusher3 move.w #17,d0
        bra made1
pusher4 move.w #-1,d0
        bra made2
made1   move.l a6,a5
        clr.w d1
search  add.w #1,d1
        add.w d0,a5
        cmp.b #1,(a5)
        beq search
        cmp.b #3,(a5)
        beq search
        cmp.b #14,(a5)
        beq search
        cmp.b #13,(a5)
        beq search
        cmp.B #20,(a5)
        beq cklp
        cmp.b #0,(a5)
        bne cklp
same    move.l a5,a4
        sub.w d0,a4
loop7   move.b (a4),(a5)
        sub.w d0,a5
        sub.w d0,a4
        dbra d1,loop7
        clr.b (a6)
        bra redraw
made2   move.l a6,a5
        clr.w d1
search2 add.w #1,d1
        add.w d0,a5
        cmp.b #2,(a5)
        beq search2
        cmp.b #3,(a5)
        beq search2
        cmp.b #14,(a5)
        beq search2
        cmp.b #13,(a5)
        beq search2
        cmp.B #20,(a5)
        beq cklp
        cmp.b #0,(a5)
        bne cklp
        bra same


\autre  move.b #13,(a0)

fini    bra redraw





ini_screen:

        move.w #20,d7
\loop2  move.w #9,d0
        bsr do_cont
        move.w #1500,d0
\loopd  move.l (a0)+,d1
        dbra d0,\loopd

        dbra d7,\loop2

        move.l #room+18,a5
        move.w #1,d0
        move.w #9,d1
        move.w #9,d6
loopd6  move.w #14,d7
loopd7  clr.l d2
        move.b (a5)+,d2
        bsr put_sprite
        add.w #9,d0
        dbra d7,loopd7
        move.w #1,d0
        add.w #9,d1
        lea 2(a5),a5
        dbra d6,loopd6
        move.w #0,d0
        move.w #8,d1
        move.w #136,d4
        move.W #91,d5
        jsr graphlib::frame
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        move.w #0,d0
        move.w #8,d1
        move.w #136,d4
        move.W #91,d5
        jsr graphlib::frame
        clr.w graphlib::choosescreen
        move.w #64,d0
        move.w #1,d1
        move.w #17,d2
        bsr put_sprite
        move.w #10,d1
        move.w #138,d0
        move.b #$FF,d3
        move.l #picture1,a0
        jsr graphlib::put_sprite_mask
        move.w #75,d0
        move.w #0,d1
        move.w #160-75,d2
        move.w #6,d3
        move.w #1,d4
        jsr graphlib::fill
        SetFont #0
        WriteStr #75,#0,#4,str
        move.l #room_str+5,a0
        clr.l d0
        move.l room_data,a1
        move.w 2(a1),d0
        divu #10,d0
        add.b #48,d0
        move.b d0,(a0)+
        swap d0
        divu #10,d0
        add.b #48,d0
        move.B d0,(a0)
        WriteStr #0,#0,#4,room_str
        move.w #6,d7
\loop   move.w #10,d0
        bsr do_cont
        move.w #1500,d0
\loopd2 move.l (a0)+,d1
        dbra d0,\loopd2
        dbra d7,\loop
        rts

put_sprite:
        move.l #mask,a2
        move.l #sprite,a0
        mulu #22,d2
        add.l d2,a0
        jsr graphlib::put_sprite2
        move.w #1,graphlib::choosescreen
        move.l graphlib::plane1,a1
        move.l #mask,a2
        move.l #plane1,a0
        add.l d2,a0
        jsr graphlib::put_sprite2
        clr.w graphlib::choosescreen
        rts


ini_lvl move.l room_data,a0
        clr.l d0
        move.w 2(a0),d0
        sub.l #89,a0
        mulu #95,d0
        add.l d0,a0
        move.l #str,a1
        moveq #19,d0
\loop   move.b (a0)+,(a1)+
        dbra d0,\loop
        move.l #save,a1
        bclr.b #0,d7
        clr.l d2
        move.w #203,d0
\loop1  move.b (a0)+,d2
        btst.b #0,d7
        bne \saute
        ror.b #4,d2
        sub.l #1,a0
\saute  and.b #%00001111,d2
        move.b d2,(a1)+
        bchg.b #0,d7
        dbra d0,\loop1
        move.l #save,a0
        move.l #room+18,a1
        moveq #9,d1
\loop2  moveq #14,d0
\loop3  move.b (a0)+,(a1)+
        dbra d0,\loop3
        lea 2(a1),a1
        dbra d1,\loop2
        rts

change_de_room:
        move.l room_data,a0
        move.w 4(a0),d0
        cmp.w 2(a0),d0
        bne plus
        cmp.w (a0),d0
        beq fin_du_jeu
        add.w #1,4(a0)
plus    move.l room_data,a0
        move.w 4(a0),d0
        cmp.w 2(a0),d0
        ble main_loop
        add.w #1,2(a0)
        move.w (a0),d0
        add.w #1,d0
        cmp.w 2(a0),d0
        bne new_room
moins:  move.l room_data,a0
        sub.w #1,2(a0)
        bne new_room
        add.w #1,2(a0)
        bra main_loop



fin_du_jeu
                       ; humn... il manque quelque chose!
                       ;
        bra new_room



        
;undo    bsr copy_board
;        clr.w d0
;        move.l #save,a0
;\loop   add.w #1,d0
;        add.l #1,a0
;        cmp.b #15,(a0)
;        beq \bon
;        cmp.b #16,(a0)
;        bne \loop
;\bon    move.w d0,pos
;        bsr redraw
;        bra main_loop
        

copy_level:
        move.l #save,a1
        move.l #room,a0
memechose:
        move.w #203,d7
\loop   move.b (a0)+,(a1)+
        dbra.s d7,\loop
        rts
copy_save:
        move.l #save,a0
encore_m_h
        move.l #room,a1
        bra.S memechose
;copy_board:
;        move.l #board,a0
;        move.l #save,a1
;        bra.s memechose
;
;save_board:
;        move.l #room,a0
;        move.l #board,a1
;        bra memechose


get_key tst.w (doorsos::kb_vars+$1C)
        beq exit
        move.w (doorsos::MaxHandles+$1E),d0
        clr.w (doorsos::kb_vars+$1C)
        rts
        


;sprites:
;
; 00 = vide
; 01 = slider vertical
; 02 = slider horizontal
; 03 = slider multidirectionnel
;
; 04 = blocker
;
; 05 = zapper vers le haut
; 06 = zapper vers la droite
; 07 = zapper vers le bas
; 08 = zapper vers la gauche
;
; 09 = pusher vers le haut
; 10 = pusher vers la droite
; 11 = pusher vers le bas
; 12 = pusher vers la gauche
;
; 13 = selector type1
; 14 = selector type2
;
; 15 = curseur
;
; 16 = selector type1 + curseur
;
; 17 = sortie du level
;
; 18 = mask
;
;
; xx bis = sprite pour le plan2


sprite  dc.w 9                 ; 00
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 01
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000100000000000
        dc.w %0001110000000000
        dc.w %0010101000000000
        dc.w %0000100000000000
        dc.w %0010101000000000
        dc.w %0001110000000000
        dc.w %0000100000000000
        dc.w %0000000000000000

        dc.w 9                 ; 02
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0111111100000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 03
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0000100000000000
        dc.w %0100100100000000
        dc.w %0111111100000000
        dc.w %0100100100000000
        dc.w %0000100000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 9
        dc.w 2                 ; 04
        dc.w %0000000000000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0000000000000000

        dc.w 9                 ; 05
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0101110100000000
        dc.w %0101010100000000
        dc.w %0111111100000000
                               
        dc.w 9                 ;06
        dc.w 2
        dc.w %0000000000000000
        dc.w %1110000000000000
        dc.w %1001100000000000
        dc.w %1110011000000000
        dc.w %1010000100000000
        dc.w %1110011000000000
        dc.w %1001100000000000
        dc.w %1110000000000000
        dc.w %0000000000000000

        dc.w 9                 ;07
        dc.w 2
        dc.w %0111111100000000
        dc.w %0101010100000000
        dc.w %0101110100000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0000000000000000

        dc.w 9                 ; 08
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000001110000000
        dc.w %0000110010000000
        dc.w %0011001110000000
        dc.w %0100001010000000
        dc.w %0011001110000000
        dc.w %0000110010000000
        dc.w %0000001110000000
        dc.w %0000000000000000

        dc.w 9                 ; 09
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0111111100000000

        dc.w 9                 ; 10
        dc.w 2
        dc.w %0000000000000000
        dc.w %1110000000000000
        dc.w %1001100000000000
        dc.w %1000011000000000
        dc.w %1000000100000000
        dc.w %1000011000000000
        dc.w %1001100000000000
        dc.w %1110000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 11
        dc.w 2
        dc.w %0111111100000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0000000000000000

        dc.w 9                 ; 12
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000001110000000
        dc.w %0000110010000000
        dc.w %0011000010000000
        dc.w %0110000010000000
        dc.w %0011000010000000
        dc.w %0000110010000000
        dc.w %0000001110000000
        dc.w %0000000000000000

        dc.w 9                 ; 13
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000

        dc.w 9                 ; 14
        dc.w 2
        dc.w %0000000000000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001010000000000
        dc.w %0000100000000000
        dc.w %0001010000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0000000000000000

        dc.w 9                 ; 15
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 9                 ; 16
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0010001000000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0100000100000000
        dc.w %0010001000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 8                 ; 17
        dc.w 2
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %0000000001111111

mask    dc.w %1111111110000000 ; 18      
        dc.w %1111111110000000        
        dc.w %1111111110000000
        dc.w %1111111110000000        
        dc.w %1111111110000000
        dc.w %1111111110000000        
        dc.w %1111111110000000
        dc.w %1111111110000000        
        dc.w %1111111110000000

plane1  dc.w 9                 ; 00 bis
        dc.w 2
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        dc.w %0000000000000000
        
        dc.w 9                 ; 01 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 02 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 03 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 04 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1010101010000000
        dc.w %1101010110000000
        dc.w %1010101010000000
        dc.w %1101010110000000
        dc.w %1010101010000000
        dc.w %1101010110000000
        dc.w %1010101010000000
        dc.w %1111111110000000

        dc.w 9                 ; 05 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000100010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1110001110000000
        dc.w %1110001110000000
        dc.w %1111111110000000

        dc.w 9                 ; 06 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1110000010000000
        dc.w %1111100010000000
        dc.w %1001111010000000
        dc.w %1001111110000000
        dc.w %1001111010000000
        dc.w %1111100010000000
        dc.w %1110000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 07 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1110001110000000
        dc.w %1110001110000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1000100010000000
        dc.w %1111111110000000

        dc.w 9                 ; 08 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000001110000000
        dc.w %1000111110000000
        dc.w %1011110010000000
        dc.w %1111110010000000
        dc.w %1011110010000000
        dc.w %1000111110000000
        dc.w %1000001110000000
        dc.w %1111111110000000

        dc.w 9                 ; 09 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000100010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1111111110000000
        dc.w %1111111110000000
        dc.w %1111111110000000

        dc.w 9                 ; 10 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1110000010000000
        dc.w %1111100010000000
        dc.w %1111111010000000
        dc.w %1111111110000000
        dc.w %1111111010000000
        dc.w %1111100010000000
        dc.w %1110000010000000
        dc.w %1111111110000000

        dc.w 9                 ; 11 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1111111110000000
        dc.w %1111111110000000
        dc.w %1011111010000000
        dc.w %1011111010000000
        dc.w %1001110010000000
        dc.w %1001110010000000
        dc.w %1000100010000000
        dc.w %1111111110000000

        dc.w 9                 ; 12 bis
        dc.w 2
        dc.w %1111111110000000
        dc.w %1000001110000000
        dc.w %1000111110000000
        dc.w %1011111110000000
        dc.w %1111111110000000
        dc.w %1011111110000000
        dc.w %1000111110000000
        dc.w %1000001110000000
        dc.w %1111111110000000

        dc.w 9                 ; 13 bis
        dc.w 2
        dc.w %1111011110000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %0000000000000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111011110000000

        dc.w 9                 ; 14 bis
        dc.w 2
        dc.w %1111011110000000
        dc.w %1100000110000000
        dc.w %1010001010000000
        dc.w %1001010010000000
        dc.w %0000100000000000
        dc.w %1001010010000000
        dc.w %1010001010000000
        dc.w %1100000110000000
        dc.w %1111011110000000

        dc.w 9                 ; 15 bis
        dc.w 2
        dc.w %0000000000000000
        dc.w %0001110000000000
        dc.w %0011111000000000
        dc.w %0111111100000000
        dc.w %0111111100000000
        dc.w %0111111100000000
        dc.w %0011111000000000
        dc.w %0001110000000000
        dc.w %0000000000000000

        dc.w 9                 ; 16 bis
        dc.w 2
        dc.w %1111011110000000
        dc.w %1001110010000000
        dc.w %1011111010000000
        dc.w %1111111110000000
        dc.w %0111111100000000
        dc.w %1111111110000000
        dc.w %1011111010000000
        dc.w %1001110010000000
        dc.w %1111011110000000

        dc.w 8                 ; 17 bis
        dc.w 2
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1000000010000000
        dc.w %1111111111111111



;level 15 * 10 + limites pour delimiter les mouvements (=20) => 17*12

room    dc.b 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20
        dc.b 20,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,20
        dc.b 20,04,04,00,00,00,04,00,04,00,04,04,04,04,00,00,20
        dc.b 20,00,00,01,13,01,00,00,04,00,04,00,00,04,00,04,20
        dc.b 20,05,00,14,04,14,04,00,00,01,00,00,02,13,02,00,20
        dc.b 20,00,08,13,00,13,00,04,00,14,04,04,04,04,00,04,20
        dc.b 20,04,00,00,00,00,00,04,00,13,00,00,02,13,02,00,20
        dc.b 20,00,00,00,00,00,00,04,07,14,04,04,04,04,00,04,20
        dc.b 20,00,00,00,00,00,00,04,00,01,06,00,02,13,02,00,20
        dc.b 20,00,02,02,03,02,00,08,00,00,04,04,07,04,00,04,20
        dc.b 20,00,00,09,00,09,00,04,15,04,04,00,00,00,00,00,20
        dc.b 20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20,20

table     dc.w -17,1,17,-1


room_data dc.l 0


str       dc.b "1234567890123456789",0
room_str  dc.b "room xx",0

title dc.b "Cyberbox version 1.0",129,0
author dc.b "by Endive",0
email dc.b "GefunS@I-France.com",0


rooms_str       dc.b "xx rooms",0

open_str dc.b "CyberBox      Choose rooms",0
help_str dc.b 23,24,"=move  [ENTER]=select  [ESC]=quits",0
no_room_str dc.b "No rooms found!",0



_comment  dc.b "Cyberbox by Endive",0

        BSS

save      ds.b 204
;board     ds.b 204

update         dc.w 0
               dc.l 0
dir            dc.b 0
pos            dc.w 0
top            dc.w 0
currentfolder  dc.w 0
nbre           dc.w 0
old_pos        dc.w 0
old_top        dc.w 0


list ds.l 200

 end
        


; by Alban Gervaise
